import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;


/**
 * ICPC - CTU Open Contest 2021
 * Sample Solution: Bread Pit
 * 
 * @author Martin Kacer
 */
public class DistributionMK {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() {
		try {
			while (!st.hasMoreTokens()) {
				String line = input.readLine();
				if (line == null) return false;
				st = new StringTokenizer(line);
			}
		} catch (IOException ex) { throw new RuntimeException(ex); }
		return true;
	}
	String nextToken() {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	public static void main(String[] args) {
		new DistributionMK().run();
	}
	
	int n, q;
	List<List<Integer>> graph;
	int[] res;
	
	void dfs(int x, long first, long period) {
		long s = graph.get(x).size() * period;
		if (s > q) s = q;
		if (s == 0) for (int i = first < q ? (int)first : q; i < q; i += period)
			res[i] = x;
		else for (int c : graph.get(x)) {
			dfs(c, first, (int)s);
			first += period;
			if (first > q) first = q;
		}
	}
	
	void run() {
		n = nextInt(); q = nextInt();
		graph = new ArrayList<>(n);
		res = new int[q];
		for (int i = 0; i < n; ++i) graph.add(new ArrayList<>());
		for (int i = 1; i < n; ++i) {
			int p = nextInt();
			graph.get(p).add(i);
		}
		dfs(0, 0, 1);
		for (int r : res) System.out.println(r);
	}
}
